/*
 * A basic extension of the java.applet.Applet class
 *
 * sorciere de samuel
 *
 * + modifs de PP pour etudier son comportement
 */

import java.awt.*;
import java.applet.*;
import java.util.Stack; // PP
import java.lang.Integer; // PP

class Robot{
    float alpha,gamma = 1/2;
    
    static int maxX = 10;       
    static int maxY = 10;

    int X,Y = 1;
    float[][] Q = new float[maxX][maxY]; // valeurs Q associes  chaque tats
    int futurX, futurY, action;
    float r=0;
    boolean haut,bas,gauche,droite,rien = true;
    int distance_initiale; // distance init entre sorciere et citrouille
    int temps; // nb iteration mis pour trouver la citrouille

    void dump () {
	for (int i = 0; i < maxX; i ++) {
	    for (int j = 0; j < maxY; j++)
		System.out.print (" " + Q [i] [j]);
	    System.out.println ();
	}
    }

    void PositionHasard() {
        X = Math.round((((float)Math.random()*((float)maxX-1))))+1;
        Y = Math.round((((float)Math.random()*((float)maxY-1))))+1;
    }    

    void Construit(){
        for (int i = 0 ; i<maxX ; i++){
            for (int j = 0 ; j<maxY ; j++){ 
                Q[i][j]= (float)Math.random();
            }
        }
        PositionHasard();
    }
    
    void Choix_Cpt(){
        float[] Qproche = new float[5];
        float max=0;
        int pos,nbmax=1;

        temps ++;

        if (X == 1) Qproche[4] = -1000000; else Qproche[4] = Q[X-2][Y-1];
        if (X == 10) Qproche[2] = -1000000; else Qproche[2] =Q[X][Y-1];
        if (Y == 1) Qproche[1] = -1000000; else Qproche[1] = Q[X-1][Y-2];
        if (Y == 10) Qproche[3] = -1000000; else Qproche[3] = Q[X-1][Y];
        max = Qproche[0] = Q[X-1][Y-1];
        pos = 0;
        
        for (int i = 1; i<5 ; i++) {
	  if (Qproche[i]>max) {
	    max = Qproche[i];
	    pos = i;
	    nbmax = 1;
	  } else if (Qproche[i]==max) {
	    nbmax++;
	  }
        }
        
        if (nbmax > 1) {
	  int sort = Math.round((((float)Math.random()*((float)nbmax))));
	  int i = 0;
	  do {
	    if ( Qproche[i] == max ) {
	      if (nbmax == 0) {
		pos = i;
	      }
	      else {
		sort--;
	      }
	    }
	    i++;
	  } while (sort > 0); 
        } 
        
        int hasard = Math.round((((float)Math.random()*((float)100000))));
        if (hasard < 1) 
	  {
	    int alea = Math.round((((float)Math.random()*((float)4))));
	    if (Qproche[alea]!= -1000000) pos = alea;
	  }
        
        action = pos;
        switch (pos) {
	case 0 :  {futurY=Y  ;futurX=X;   break;}
	case 1 :  {futurY=Y-1;futurX=X;   break;}
	case 2 :  {futurY=Y  ;futurX=X+1; break;}
	case 3 :  {futurY=Y+1;futurX=X;   break;}
	case 4 :  {futurY=Y  ;futurX=X-1; break;}
        }        
    }
  
  void ModifieQ(){ 
    float[] Qproche = new float[5];
    float max;
    
    if (futurX == 1) 
	Qproche[4] = -1000000; 
    else Qproche[4] = Q[futurX-2][futurY-1];

    if (futurX == 10) 
	Qproche[2] = -1000000; 
    else Qproche[2] =Q[futurX][futurY-1];

    if (futurY == 1) 
	Qproche[1] = -1000000; 
    else Qproche[1] = Q[futurX-1][futurY-2];

    if (futurY == 10) 
	Qproche[3] = -1000000; 
    else Qproche[3] = Q[futurX-1][futurY];
    
    max = Qproche[0] = Q[futurX-1][futurY-1];
    
    for (int i = 1; i<5 ; i++) {
      if (Qproche[i] > max) {
	max = Qproche[i];
      }
    }   
    
    Q[X-1][Y-1] = Q [X-1] [Y-1] + (float)((r+(float)(max/2)-Q[X-1][Y-1])/2);
  }  
}


public class RobotQLearning extends Applet implements Runnable
{
  static Stack stk = new Stack(); // PP
  Image RobotImg,TresorImg,TresorRobotImg;
  Robot LeRobot = new Robot();
  boolean bloque = true;
  int AncienX, AncienY, AncienXTres, AncienYTres = 0;
  int TresorX, TresorY = 0;
  
  public void PlaceTresor() {
    Integer Ix = new Integer (TresorX); // PP
    Integer Iy = new Integer (TresorY); // PP
      
    stk. push (Ix); // PP
    stk. push (Iy); // PP
    
    TresorX = Math.round((((float)Math.random()*((float)10-1))))+1;
    TresorY = Math.round((((float)Math.random()*((float)10-1))))+1;
    
    System.out.println ("place position " + TresorX + " " + TresorY);
    
  }
  
  // methode PrevTresor() par PP
  public void PrevTresor() {
    if (! stk. empty ()) {
      TresorY = ((Integer) (stk. pop ())). intValue ();
      TresorX = ((Integer) (stk. pop ())). intValue ();
      
      System.out.println ("prev position " + TresorX + " " + TresorY);
    } else {
      System.out.println ("pile vide");
    }
  }
  
    // methode dump par PP
    public void dump () {
	LeRobot. dump ();
    }

  Thread runner;
  
  public void start() {
    if (runner == null) {
      runner = new Thread(this);
      runner.start();
    }
  }
  
  public void stop() {
    if (runner != null) {
      runner.stop();
      runner = null;
    }
  }

  public void init()
    {
      // Take out this line if you don't use symantec.itools.net.RelativeURL 
      // or symantec.itools.awt.util.StatusScroller
      //		symantec.itools.lang.Context.setApplet(this);
      
      // This code is automatically generated by Visual Cafe when you add
      // components to the visual environment. It instantiates and initializes
      // the components. To modify the code, only use code syntax that matches
      // what Visual Cafe can generate, or Visual Cafe may be unable to back
      // parse your Java file into its visual environment.
      //{{INIT_CONTROLS
      setLayout(null);
      setSize(788,535);
      button1 = new java.awt.Button();
      button1.setActionCommand("button");
      button1.setLabel("Dplacer la cible");
      button1.setBounds(636,192,132,40);
      button1.setBackground(new Color(12632256));
      add(button1);
      button2 = new java.awt.Button();
      button2.setActionCommand("button");
      button2.setLabel("Dplacer le mobile");
      button2.setBounds(636,132,132,40);
      button2.setBackground(new Color(12632256));
      add(button2);
      button3 = new java.awt.Button();
      button3.setActionCommand("button");
      button3.setLabel("Commencer");
      button3.setBounds(636,72,132,40);
      button3.setBackground(new Color(12632256));
      add(button3);
      button4 = new java.awt.Button(); // PP
      button4.setActionCommand("button"); // PP
      button4.setLabel("Prev"); // PP
      button4.setBounds(636,252,132,40); // PP
      button4.setBackground(new Color(12632256)); // PP
      add(button4); // PP
      button5 = new java.awt.Button(); // PP
      button5.setActionCommand("button"); // PP
      button5.setLabel("Dump"); // PP
      button5.setBounds(636,312,132,40); // PP
      button5.setBackground(new Color(12632256)); // PP
      add(button5); // PP
      checkbox1 = new java.awt.Checkbox("grille");
      checkbox1.setBounds(648,374,100,40); // PP : 314 au lieu de 264, puis 374
      add(checkbox1);
      //}}

      RobotImg = getImage(getCodeBase(),"sorciere.gif");
      TresorImg = getImage(getCodeBase(),"citrouille.gif");
      TresorRobotImg = getImage(getCodeBase(),"sorciere.gif");

      LeRobot.Construit();
      PlaceTresor();
      LeRobot. distance_initiale = 
	  (LeRobot. X > TresorX ? LeRobot. X - TresorX : TresorX - LeRobot. X) +
 	  (LeRobot. Y > TresorY ? LeRobot. Y - TresorY : TresorY - LeRobot. Y);
      LeRobot. temps = 0;

      //{{REGISTER_LISTENERS
      SymMouse aSymMouse = new SymMouse();
      button2.addMouseListener(aSymMouse);
      button1.addMouseListener(aSymMouse);
      button3.addMouseListener(aSymMouse);
      button4.addMouseListener(aSymMouse); // PP
      button5.addMouseListener(aSymMouse); // PP
      checkbox1.addMouseListener(aSymMouse);
      //}}
    }

  //{{DECLARE_CONTROLS
  java.awt.Button button1;
  java.awt.Button button2;
  java.awt.Button button3;
  java.awt.Button button4; // PP
  java.awt.Button button5; // PP
  java.awt.Checkbox checkbox1;
  //}}
  
  public void AfficheRobot(Graphics g,int posX, int posY) {
    int iwidth = RobotImg.getWidth(this);
    int iheight = RobotImg.getHeight(this);
    int x,y;
    x = 3+24 + ((posX - 1)*46);
    y = 3+12 + ((posY - 1)*46);
    g.drawImage(RobotImg, x, y, iwidth, iheight, this);
  }
  
  public void AfficheTresor(Graphics g, int posX, int posY) {
    int iwidth = TresorImg.getWidth(this);
    int iheight = TresorImg.getHeight(this);
    int x,y;
    x = 2+24 + ((posX - 1)*46);
    y = 2+12 + ((posY - 1)*46);
    g.drawImage(TresorImg, x, y, iwidth, iheight, this);
  }
  
  public void AfficheTresorRobot(Graphics g, int posX, int posY) {
    int iwidth = TresorImg.getWidth(this);
    int iheight = TresorImg.getHeight(this);
    int x,y;
    x = 2+24 + ((posX - 1)*46);
    y = 2+12 + ((posY - 1)*46);
    g.drawImage(TresorRobotImg, x, y, iwidth, iheight, this);
  }
  
  public void Efface(Graphics g, int posX, int posY) {
    int x1,x2,y1,y2 = 0;
    x1= 2+24 + ((posX - 1)*46);
    y1= 2+12 + ((posY - 1)*46);
    x2 = 31 + x1;
    y2 = 31 + y2;
    g.clearRect(x1,y1,44,44);
  }
  
  public void AfficheGrille(Graphics g) {
    int x1,x2,y1,y2 = 0;
    
    g.setColor(Color.black);
    
    for (int i = 0 ; i<=10 ; i++) {
      x1=24;
      x2=24+(46*10);
      y1 = y2 = 12 + (i*46);
      g.drawLine(x1,y1,x2,y2);
    }
    
    for (int i = 0 ; i<=10 ; i++) {
      x1 = x2= 24 + (i*46);
      y1 = 12;
      y2 = 12+(46*10);
      g.drawLine(x1,y1,x2,y2);
    }	    
  }
  
  public void EffaceGrille(Graphics g) {
    int x1,x2,y1,y2 = 0;
    
    g.setColor(Color.white);
    
    for (int i = 0 ; i<=10 ; i++) {
      x1=24;
      x2=24+(46*10);
      y1 = y2 = 12 + (i*46);
      
      g.drawLine(x1,y1,x2,y2);
    }
    
    for (int i = 0 ; i<=10 ; i++) {
      x1 = x2= 24 + (i*46);
      y1 = 12;
      y2 = 12+(46*10);
      g.drawLine(x1,y1,x2,y2);
    }	    
  }

  public void paint(Graphics g) {
    if (checkbox1.getState()) 
      AfficheGrille(g);
    else 
      EffaceGrille(g);
    
    if (AncienX != LeRobot.X | AncienY != LeRobot.Y)
      Efface(g,AncienX,AncienY);    
    if (AncienXTres != TresorX | AncienYTres != TresorY )
      Efface(g,AncienXTres,AncienYTres);
    
    
    if ((TresorX==LeRobot.X) & (TresorY==LeRobot.Y))
      AfficheTresorRobot(g,TresorX,TresorY);
    else {
      AfficheTresor(g,TresorX,TresorY);
      AfficheRobot(g,LeRobot.X,LeRobot.Y);
    }    
    AncienX = LeRobot.X;
    AncienY = LeRobot.Y;
  }
  
  public void update(Graphics g) {
    paint(g);
  }    

  public void run() {
      while (true) {
	  while (bloque) {};

	  LeRobot.Choix_Cpt();

	  if (LeRobot.X == TresorX & LeRobot.Y == TresorY) {
	      //	      if (!found) {
	      //		  found = true;
	      //		  System.out.println (" " + distance_initiale + " " + temps);
	      LeRobot.r = 10;
	  }
	  else LeRobot.r = -1;

	  LeRobot.ModifieQ ();
	  LeRobot.X = LeRobot.futurX;
	  LeRobot.Y = LeRobot.futurY;
	  repaint();

	  try { Thread.sleep(100); }
	  catch (InterruptedException e) {}
      }
  }
  
  class SymMouse extends java.awt.event.MouseAdapter {
    
    public void mouseClicked(java.awt.event.MouseEvent event) {
      Object object = event.getSource();
      if (object == button2)
	button2_MouseClick(event);
      else if (object == button1)
	button1_MouseClick(event);
      else if (object == button4) // PP
	button4_MouseClick(event); // PP
      else if (object == button5) // PP
	button5_MouseClick(event); // PP
      else if (object == button3) {
	button3_MouseClick(event);
	System.out.println("RECOMMENCER");
      } else if (object == checkbox1)
	checkbox1_MouseClick(event);
    }
  }
  
  void button2_MouseClick(java.awt.event.MouseEvent event) {
      LeRobot.PositionHasard();
      repaint();
  }

  void button4_MouseClick(java.awt.event.MouseEvent event) {
    AncienXTres = TresorX;
    AncienYTres = TresorY;
    PrevTresor();
    repaint();
  }
  
  void button5_MouseClick(java.awt.event.MouseEvent event) {
      dump ();
      repaint();
  }
  
  void button1_MouseClick(java.awt.event.MouseEvent event) {
    AncienXTres = TresorX;
    AncienYTres = TresorY;
    PlaceTresor();
    repaint();
  }
  
  void button3_MouseClick(java.awt.event.MouseEvent event) {
    if (bloque) {
      button3.setLabel( "Recommencer");
      bloque=false;
    }
    else {
      runner.resume();
      //init();
    }
  }
  
  void checkbox1_MouseClick(java.awt.event.MouseEvent event) {
    // to do: code goes here.
    repaint();
  }
}
